package arm

import "git.urbach.dev/cli/q/src/cpu"

// encodeRegisterNumberFlags performs addition or subtraction on the given register
// and optionally updates the condition flags based on the result.
func encodeRegisterNumberFlags(op uint32, destination cpu.Register, source cpu.Register, number int, flags bool) uint32 {
	number &= 0b1111_1111_1111
	common := op<<30 | 0b100010<<23 | (uint32(number) << 10) | (uint32(source) << 5) | uint32(destination)

	if flags {
		return 1<<29 | common
	}

	return common
}
